#!/usr/local/bin/perl
#
#
# DCShop Version 1.0 (10 Dec 1998)
# An Electronic Shopping Cart Program
# Copyright  1997-1998 DCScripts All Rights Reserved
#
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCShop.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
# 
# LICENSE TO REDISTRIBUTE
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the DCShop software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# DISCLAIMER OF WARRENTY
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH DCSHOP MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF DCSCRIPTS WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPTS LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
###########################################################################
# Define directory path to your setup file.
# Use relative path if you can

$path = ".";

#----DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING---#

# require setup file and cgi-lib library file
require "$path/dcshop.setup";
require "$path/dclib.pl";
require "$path/cgi-lib.pl";

# Read in formdata
ReadParse();

# Define global variables
$productID = $in{'productID'};
$category = $in{'category'};
$in{'cart_dir'} = $cart_dir;

# Get cookie - that is, cart id
$cart_id = get_cookie($key);

# Check and see if action is either
# check_out or re_calc

if ($in{'check_out'}) {
	unless ($cart_id) {
		print "\n";
		print "empty_cart";
		exit(0);
	}
	print "Location: $checkout_script?$cart_id\n\n";
	exit;
}
elsif ($in{'re_calc'}) {
	$in{'action'} = "re_calc";
}
elsif ($in{'empty'}) {
	$in{'action'} = "empty_cart";
}

# data file path and name - no need to create it
# This program will look for database file, setup file
# and counter file.  The only file needed is the setup file

if ($in{'database'}) {
	$database = $in{'database'} . "\.txt";
	$setup = $in{'database'} . "\.setup";
	require "$datadir/$setup";
	$datafile = "$datadir/$database";
}

# Send HTTP header to the server
# Note that the output header it not
# terminated yet.  Must print at least one more
# \n ...

print "Content-type: text/html\n";

if ($in{'action'} eq "view_category") {

	# print end of HTTP header	
	print "\n";

	$header = $h_cat;
	$sub_header .= qq~
	$sh_cat
	<P align="center">
	<font face="$font_face{0}"
		color="$font_color{0}" size="$font_size{0}">
	<B>Items in $category[$category]</B>
	</font>
	</p>
	~;

	# print menu links to $sub_header

	$menu = display_menu ("1",\%in,\%category_list);
	$html_output = list_category($datafile);

}
elsif ($in{'action'} eq "view_product") {

	print "\n";

	$header = $h_pro;
	$sub_header = $sh_pro;
	$menu = display_menu ("1",\%in,\%category_list) ;

	$html_output = product_display($datafile,$productID,\%in);

	$html_output .= qq~
	<P align="center">
	<font face="$font_face{0}"
		color="$font_color{0}" size="$font_size{0}">
	<B>Items in $category[$category]</B>
	</font>
	</p>
	~;
	
	$html_output .= list_category($datafile);

}
elsif ($in{'action'} eq "add_to_cart") {

	# Add to Cart - return $cart_id
	# If $card_id is not present, then
	# get new cart id, create a cart, and set cookie

	unless ($cart_id) {
		$cart_id = get_cart_id();
		create_file("$cart_dir/$cart_id.cart");
		send_cookie($key,$cart_id,$expires,$domain);
	}

	# End HTTP header

	print "\n";

	$qty = $in{'Quantity'};
	$line = get_cart_item(\%in);
	appenddata("$cart_dir/$cart_id.cart",$line);

	# Display output
	
	$header = $h_cart;
	$sub_header .= qq~
		<B>Your item has been added to the cart<br>
		Your cart now contains following items</b>
		</center>
		<blockquote>
		$sh_cart
		</blockquote>
		<center>
	~;

	$html_output = view_cart(\%in,$cart_id);

}
elsif ($in{'action'} eq "view_cart") {

	print "\n";

	$header = $h_cart;
	$sub_header .= qq~
	<B>Your cart contains following items</b>
	</center>
	<blockquote>
	$sh_cart
	</blockquote>
	<center>
	~;

	if ($cart_id && -e "$cart_dir/$cart_id.cart") {
		$html_output = view_cart(\%in,$cart_id);
	}
	else {
		$html_output = "<h3 align=\"center\">Your cart is empty</h3>";
	}

}
elsif ($in{'action'} eq "product_info") {

	print "\n";
	$menu = display_menu ("1",\%in,\%category_list) ;
	$header = $h_pro;
	$sub_header = $sh_pro;
	$html_output = product_display($datafile,$productID,\%in);

}
elsif ($in{'action'} eq "empty_cart") {

	$expires = "Thu, 31-Dec-97 12:00:00 GMT";
	&send_cookie($key,$cart_id,$expires,$domain);

	print "\n";

	if ($cart_id) {
		if (-e "$cart_dir/$cart_id.cart") {
			unlink("$cart_dir/$cart_id.cart") or 
				my_die("Can't remove $cart_dir/$cart_id.cart",$!);
		}
	}

	$header = $h_empty;
	$sub_header = $sh_empty;

}
elsif ($in{'action'} eq "re_calc") {

	print "\n";
	# First read in $cookie{'customerID'}
	# then call subroutine re_calc

	$header = $h_cart;
	$sub_header .= qq~
	<B>Your cart contains following items</b>
	</center>
	<blockquote>
	$sh_cart
	</blockquote>
	<center>
	~;

	$cart_id = get_cookie($key);

	if ($cart_id && -e "$cart_dir/$cart_id.cart") {
		re_calc(\%in,$cart_id);
		$html_output = view_cart(\%in,$cart_id);
	}
	else {
		$html_output = "<h3 align=\"center\">Your cart is empty</h3>";
	}

}
elsif ($in{'action'} eq "keyword_search") {

	# End HTTP Header
	print "\n";

	$menu = display_menu ("1",\%in,\%category_list) ;	

	$header = $h_search;
	$sub_header = $sh_search;

	#split keywords to multiple words

	@keywords = split(/\s+/,$in{'keywords'});
	$html_output = "";
	$html_output .= keyword_search(\%super_cat,\@keywords,\%in);


}
elsif ($in{'database'}) {

	print "\n";

	# create menu links and assign to sub_header

	$menu = display_menu("0",\%in,\%super_cat) ;

	$header = $h_main;
	$sub_header = $sh_main;
	
	$html_output = display_main ( $datafile,
		\%category_list, \%category_desc, \%in);

}
else {

	# End HTTP Header
	print "\n";
	# create menu links and assign to sub_header
	$menu = display_menu("0",\%in,\%super_cat) ;
	$header = $h_super;
	$sub_header = $sh_super;

	$html_output .= qq~
	<table border="0" width="100%" cellspacing="1" cellpadding="4">
	<tr bgcolor="$bg_color{'1'}" align="left">
	<th>
	<font face="$font_face{'1'}" size="$font_size{'1'}"
	color="$font_color{'1'}">
	Category
	</font>
	</th>
	<th>
	<font face="$font_face{'1'}" size="$font_size{'1'}"
	color="$font_color{'1'}">
	Description
	</font>
	</th>
	</tr>
	~;

	foreach (sort keys %super_cat) {

		&toggle_color();

		$html_output .= qq~
		<tr>
		<td valign="top" align="left" bgcolor="$bgcolor">
		<a href="$dcscript?database=$super_cat{$_}"><font 
			size="$fontsize" face="$fontface"
			color="$fontcolor">$_</a></font>
		</td>
		<td valign="top" align="left"  bgcolor="$bgcolor"><font 
			size="$fontsize" face="$fontface"
			color="$fontcolor">
		$super_cat_desc{$_}
		</font>
		</td>
		</tr>
		~;
	}

	$html_output .= qq~
		<tr bgcolor="$bg_color{1}" align="left">
		<th colspan="2">&nbsp;</th>
		</tr></table>
	~;

}

#
# Finally display output to the browser
# 

$imageurl = $imgurl;

my %namespace = (
	 IMAGES => $imageurl,
    HEADER => $header,
    SUBHEADER => $sub_header,
    MENU => $menu,
    HTMLOUTPUT => $html_output );

display_output($templatefile,\%namespace); 

exit(0);

############################################################################
####################### END OF THE MAIN PROGRAM ############################
############################################################################


#####
# list_category
#####

sub list_category {

	my ($datafile) = shift;
	my ($html_output);

	# Get all items
	my $r_data = readdata($datafile);

	# Prepare HTML text
	$html_output .= qq~
	<table border="0" cellspacing="1" cellpadding="4" width="100%">~;

	foreach (@list_fields) {
		my $record = $_;
		$record =~ s/OPT_(.*)/$1 (Option)/;
		$html_output .= qq~
		<th bgcolor="$bg_color{1}" align="left"><font face="$font_face{1}"
			color="$font_color{1}" size="$font_size{1}">
			$record</font></th>~;	
	}

	# Since first row of $datafile contains fields		
	# shift out Fields

	my $fields = shift @{$r_data};

	# Now, go thru each record in $datafile
   # and print those that have correct category

	foreach (@{$r_data}) {
		chomp;
		my @row = split /\|/;

		# Put record in $r_rowdata hash reference

		foreach ($j=0; $j<@row ;$j++) {
			$r_rowdata->{$link_fields[$j]} = $row[$j];
		}

		if ($row[$cat_id] eq $category) {
			&toggle_color();
			$html_output .= "<tr valign=\"top\" bgcolor=\"$bgcolor\">\n";
			$html_output .= list_record($r_rowdata,\@link_fields,\@list_fields,\%in);
			$html_output .= "</tr>\n";
		}

	}
	$html_output .= qq~
		<tr bgcolor="$bg_color{1}" align="left">
		<th colspan="3">&nbsp;</th>
		</tr></table>
	~;
	
	return $html_output;
}
#####
#
# function get_cart_item
# Gets one record from the database
# and returns it so that it can be
# append to the shopping cart
#
#####

sub get_cart_item {

	my $r_in = shift;

	# get product record and put it in a hash

	my ($record,$r_fields) = get_row($datafile, $productID);
	my @row = split (/\|/,$record);

	foreach ($j=0; $j<@row ;$j++) {
		$r_rowdata->{$link_fields[$j]} = $row[$j];
		if ($link_fields[$j] =~ /OPT_(.*)/) {
			push(@option, "$1=$r_in->{$link_fields[$j]}" );
		}
	}

	foreach (@cart_fields) {

		if ($_ eq "Quantity") {
			push(@temp,"$r_in->{'Quantity'}");
		}
		elsif ($_ eq "Options") {

			if (@option) {
				$option = join(",",@option);
				push(@temp,"$option");
			} else {
				push(@temp,"NA");
			}

		}
		else {
			push(@temp,"$r_rowdata->{$_}");
		}
	}

	$item = join("\|",@temp);
	return $item;

}

#####
# function get_row
#####

sub get_row {

	my ($datafile,$productID) = @_;
	my $r_data = readdata($datafile);
	
	my $fields = shift(@{$r_data});
	chomp($fields);
	my $r_fields = [ split(/\|/,$fields) ];

	foreach (@{$r_data}) {
		chomp;
		if ($_ =~ /^$productID\|/) {
			return ($_,$r_fields);
		}
	}
	return 0;
}

############################################################################
#
# subroutine re_calc - re-calculates the
#	items in the cart
#
# Input:
#					$r_in - reference to %in
#					$value - $cookie{'customerID'}
# Output:
#					print $template to STDOUT
#
############################################################################

sub re_calc {

	my ($r_in,$cart_id) = @_;
	my ($html_output,@new);

	# Stript off items to recalc
	# If quantity is less than or equal to 0 then remove it

	my $r_data = readdata("$cart_dir/$cart_id.cart");

	foreach (keys %{$r_in}) {
		if ($_ =~ /Quantity_(.*)/) {
			if ($r_in->{$_} > 0) {
				$quantity{$1} = $r_in->{$_};
			}
		}
	}

	foreach $item (@$r_data) {
		chomp($item);
		my @items = split(/\|/,$item);
		foreach (keys %quantity) {
			if ($items[0] eq $_) {
				$items[$quantity_key] = $quantity{$_};
				$item = join("\|",@items);
				push(@new,"$item\n");
				last;
			}
		}
	}

	writedata("$cart_dir/$cart_id.cart",\@new);

}

############################################################################
#
# subroutine display_main
# -- Displays the main page
# Input:
#
#       $datafile - database file name
#       $r_category_list - reference to %category_list
#       $r_category_desc - reference to %category_desc
#       $r_in - reference to %in - the form variable
#
# Output:
#
#
############################################################################

sub display_main {

	my ($datafile, $r_category_list,$r_category_desc,$r_in) = @_;
	my $output;

	# Read in all the rows of data

	my $r_data = readdata($datafile);

	# Determine the number of items in each category
	
	foreach (@$r_data) {
		my @rowdata = split(/\|/,$_);
		$category_num{$rowdata[$cat_id]}++;
	}

	$output .= qq~
	<table border="0" width="100%" cellpadding="4" cellspacing="1">
	<tr bgcolor="$bg_color{'1'}" align="left">
	<th>
	<font face="$font_face{1}"
		color="$font_color{1}" size="$font_size{1}">
	Category
	</font>
	</th>
	<th>
	<font face="$font_face{1}"
		color="$font_color{1}" size="$font_size{1}">
	Description
	</font>
	</th>
	</tr>
	~;
		
	foreach (sort keys %$r_category_list) {

		&toggle_color();
				
		$cat1 = $r_category_list->{$_};

		if ($category_num{"$cat1"} eq "" ) {
			$category_num{"$cat1"} = "0";
		}

		$output .= qq~
		<tr valign="top" align="left" bgcolor="$bgcolor">
		<td>
		<a href="$dcscript?action=view_category
			&database=$r_in->{'database'}&category=$cat1"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
			$_</a></font>
		</td>
		<td>
		<font size="$fontsize" face="$fontface" color="$fontcolor">
		($category_num{"$cat1"} Items)
		 $r_category_desc->{$_}</font>
		</td>
		</tr>
		~;
	}

	$output .= qq~
		<tr bgcolor="$bg_color{1}" align="left">
		<th colspan="2">&nbsp;</th>
		</tr></table>
	~;

	$output;

}



############################################################################
#
# subroutine view_cart
# -- Display items in the cart
# Input:
#
#
# Output:
#
#
############################################################################

sub view_cart {

	my ($r_in,$cart_id) = @_;
	my ($output);
	my ($total_nontaxable, $total_taxable, $total_tax, $final);
	
	# Top portion of the output text

	$output .= qq~
	<form action="$dcscript" method="post">
	<table width="100%" border="0" cellspacing="1" cellpadding="3">
	<tr bgcolor="$bg_color{'1'}" align="left">~;

	foreach (@cart_fields) {
		unless ($_ eq "Taxable") {
			$output .= qq~
			<th><font face="$font_face{1}"
				color="$font_color{1}" size="$font_size{1}">$_</font></th>
			~;
		}
	}
	
	$output .= qq~
		<th><font face="$font_face{1}"
			color="$font_color{1}" size="$font_size{1}">Amount</font></th>
	</tr>
	~;

	# Read in items into reference array
	my $r_cart = readdata("$cart_dir/$cart_id\.cart");

	&toggle_color('reset');

	foreach (@{$r_cart}) {
		chomp;
		my @row = split /\|/;
		$output .= "<tr valign=\"top\" align=\"left\" bgcolor=\"$bgcolor\">\n";

		my $j = -1;
		my $taxable;

		foreach (@row) {

			$j++;
			if ($cart_fields[$j] eq "ID") {
				$id = $_;
				$output .= qq~
				<td align="right"><font
					size="$fontsize" face="$fontface" color="$fontcolor">
					$id</font>
				</td>~;
			}
			elsif ($cart_fields[$j] eq "Price") {
				$price = sprintf("%.2f", $_);
				$output .= qq~
				<td align="right"><font
					size="$fontsize" face="$fontface" color="$fontcolor">
					\$$price</font>
				</td>~;
			}
			elsif ($cart_fields[$j] eq "Quantity") {
				$quantity = $_;
				$output .= qq~
				<td><font
					size="$fontsize" face="$fontface" color="$fontcolor"><input
					type="text" name="Quantity_$id" value="$_" size="5">
					</font>
				</td>~;
			}
			elsif ($cart_fields[$j] eq "Taxable") {
				$taxable = $_;
			}
			elsif ($cart_fields[$j] eq "Options") {
				$output .= qq~
				<td align="right"><font
					size="$fontsize" face="$fontface" color="$fontcolor">~;
				my (@options) = split /,/;
				foreach (@options) {
					my ($temp,$opt_price);
					my ($option,$choice) = split /=/;
					if ($choice =~ /::/) {
						($temp,$opt_price) = split(/::/,$choice);
						$price += $opt_price;
						$choice = $temp;
						$output .= qq~
							$option: $choice (+\$$opt_price)<br>~;
					}
					elsif ($_ eq "NA") {
						$output .= qq~
							&nbsp;~;
					}
					else {
						$output .= qq~
							$option: $choice<br>~;
					}
				}

				$output .= qq~
					</font>
				</td>~;
			}
			else {
				$output .= qq~
				<td>&nbsp;<font
					size="$fontsize" face="$fontface" color="$fontcolor">
					$_</font>
				</td>~;
			}

		}

		toggle_color();

		$sub_total = sprintf("%.2f", $price * $quantity);

		if ($taxable) {
			$total_taxable += $sub_total;
		}
		else {
			$total_nontaxable += $sub_total;
		}

		$output .= qq~
		<td align="right"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
			\$$sub_total</font>
		</td>
		</tr>~;
	}
	
	$total_nontaxable = sprintf("%.2f", $total_nontaxable);
	$total_taxable = sprintf("%.2f", $total_taxable);
	$total_tax = sprintf("%.2f", $total_taxable*$sales_tax);
	$final = sprintf("%.2f", $total_nontaxable + $total_taxable + $total_tax);

	$output .= qq~
	<tr>
		<td colspan="6" align="right"><hr size="1">$taxable</td>
	</tr>
	<tr>
		<td colspan="4" align="right">&nbsp;</td>
		<th align="right" valign="top"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
		Total (Non-Taxable):
		</font></th>
		<td align="right" valign="top"><font
			size="$fontsize" face="$fontface" 
			color="$fontcolor">\$$total_nontaxable</font></td>
	</tr>
	<tr>
		<td colspan="4" align="right">&nbsp;</td>
		<th align="right" valign="top"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
		Total (Taxable):
		</font></th>
		<td align="right" valign="top"><font
			size="$fontsize" face="$fontface" 
			color="$fontcolor">\$$total_taxable</font></td>
	</tr>
	<tr>
		<td colspan="4" align="right" valign="top">&nbsp;
		</td>
		<th align="right" valign="top"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
		Sales Tax:
		</font>
		</th>
		<td align="right"><font
			size="$fontsize" face="$fontface" 
			color="$fontcolor">\$$total_tax</font></td>
	</tr>
	<tr>
		<td colspan="4" align="right">&nbsp;
		</td>
		<th align="right" valign="top"><font
			size="$fontsize" face="$fontface" color="$fontcolor">
		Total:
		</font>
		</th>
		<td align="right" valign="top"><font
			size="$fontsize" face="$fontface" 
			color="$fontcolor">\$$final</font></td>		
	</tr>
	<tr>
		<td colspan="6" align="right"><hr size="1"></td>
	</tr>
	<tr>
		<th colspan="6" align="center">
		<input type="submit" value="Continue">
		<input type="submit" name="check_out" value="Check Out">
		<input type="submit" name="re_calc" value="Recalculate">
		<input type="submit" name="empty" value="Empty Cart">
		</th>
	</tr>
	</table>
	</form>
	~;
	
	$output;

}

############################################################################
#
# subroutine list_record
# -- Displays list single record at at time
# Input:
#
#
# Output:
#
#
############################################################################

sub list_record {

	my($r_rowdata,$r_link_fields,$r_list_fields,$r_in) = @_;

	my($output);

	foreach (@$r_list_fields) {
		if ($_ eq "Name") {
			$output .= qq~
			<td>
				<font size="$fontsize" color="$fontcolor" face="$fontface">
				<a href="$dcscript?database=$r_in->{'database'}&action=
				view_product&productID=
				$r_rowdata->{$r_link_fields->[$product_id]}&category=$category">$r_rowdata->{$_}</a>
				</font>
			</td>
			~;
		}
		elsif ($_ eq "Price") {
			$output .= qq~
			<td>
				<font size="$fontsize" color="$fontcolor" face="$fontface">
				\$$r_rowdata->{$_}
				</font>
			</td>
			~;
		}
		else {
			$output .= qq~
			<td>
				<font size="$fontsize" color="$fontcolor" face="$fontface">
				$r_rowdata->{$_}
				</font>
			</td>
			~;
		}
	}

	$output;
}


############################################################################
#
# subroutine desc_record
# -- Displays single record in a detail mode
# Input:
#
#
# Output:
#
#
############################################################################

sub desc_record {

	my($r_rowdata,$r_link_fields,$r_in,$buyFlag) = @_;

	# First read in $print_fields to search and replace

	my $output = $print_fields;
	my %search_replace = {};
	my $option_flag;

	foreach (@{$r_link_fields}) {
		if ($_ eq "Image" && $r_rowdata->{$_} ne "") {
			$search_replace{$_} = "<img src=\"$imgurl/$r_rowdata->{$_}\" border=\"0\">";
		}
		elsif ($_ eq "Price") {
			$search_replace{$_} = "<b>Price:</b> \$$r_rowdata->{$_}";
		}
		elsif ($_ =~ /OPT_(.*)/) {
			unless ($option_flag) {
				$search_replace{'Option'} .= "<b>Options:</b><p>";
				$option_flag = "checked";
			}
			my @options = split(/,/, $r_rowdata->{$_});
			my $string = "<select name=$_>\n";
			foreach (@options) {
				if ($_ =~ /::/) {
					my ($opt,$opt_price) = split /::/;
					$string .= qq~
						<option value="$_">$opt (Add \$$opt_price)
						~;
				}
				else {
					$string .= "<option value=\"$_\">$_\n";
				}
			}
			$string .= "</select>\n";
			$search_replace{'Option'} .= "$1: $string<br>";
		}
		else {
			$search_replace{$_} = "$r_rowdata->{$_}\n";
		}
	}

	$search_replace{'Quantity'} .= qq~
	<b>Quantity:</b>
	<input type="text" name="Quantity" value="1" size="5">
	</font><br>&nbsp;<br>
	~;

	if ($buyFlag) {
		$search_replace{"Cart"} = 
			"[ <a href=\"$dcscript\?database=$r_in->{'database'}&action=product_info&productID=$productID\">Add to Cart</a> ]";		
	}

	$output =~ s/<!--\%([A-Za-z]+)\%-->/
          my $value = $search_replace{$1};
          $value;
          /ge;
	$output;
}

############################################################################
#
# subroutine display_menu
# Input:
#
#
# Output:
#
#
############################################################################

sub display_menu {

	my ($level, $r_in, $r_category_list) = @_;
	my ($menu);

	# $level eq "0" means that the menu we create is for the
	# main category level.  In this case, display links to
	# the top level categories.  Otherwise, link to each sub categories

	if ($level eq "0") {

		$menu .= qq~
			[<a href="$dcscript"><b>Main Page</b></a>]
			[<a href="$dcscript?action=view_cart"><b>View Cart</b></a>]
			[<a href="$dcscript?action=empty_cart"><b>Empty Cart</b></a>]
			<br>
		~;

		foreach (sort keys %$r_category_list) {
			my $database = $r_category_list->{$_};		# database name
			$menu .= qq~
				[<a href="$dcscript?database=$database">$_</a>] ~;			
		}

	}
	else {

		$menu .= qq~
			[<a href="$dcscript"><b>Main Page</b></a>]
			[<a href="$dcscript?action=view_cart"><b>View Cart</b></a>]
			[<a href="$dcscript?action=empty_cart"><b>Empty Cart</b></a>]
			<br>
		~;


		foreach (sort keys %$r_category_list) {
			my $sub_cat = $r_category_list->{$_};		# $sub_cat - sub category
			$menu .= qq~
				[<a href="$dcscript?action=view_category
					&database=$r_in->{'database'}&category=$sub_cat">$_</a>]
			~;
		}

	}

	# print out search engine at the top

	$menu .= qq~
		<center>
		<form action="$dcscript" method="post">
		<input type="hidden" name="action" value="keyword_search">
		Keyword Search <input type="text" name="keywords" size="20">
		<input type="submit" value="Go!">
		</form>
		</center>
	~;
	
	# return reference to menu text

	$menu;
}

############################################################################
#
# subroutine keyword_search
#
# Input:
#
#
# Output:
#
#
############################################################################

sub keyword_search {

	my($r_super_cat,$r_keywords,$r_in) = @_;
	my($output);

	# For each database, we need to scan for key word hit

	my $yeshits = "";

	foreach $file (values %$r_super_cat) {

		# Initialize
		require "$datadir/$file.setup";
		my $anyhit = "";
		my $datafile = "$datadir/$file.txt";
		my $r_data = readdata($datafile);
		my $buffer;
		
		$r_in->{'database'} = $file;
		$j=0;
		foreach (@category) {
			$j++;
			$category_list{$_} = $j;
		}

		# Get rid of the first line of database
		# which just contains field names
		
		my $fields = shift(@{$r_data});
		chomp($fields);
		my @link_fields = split(/\|/,$fields);
		
		foreach $line (@{$r_data}) {		
			chomp $line;
			my $hit = "";

			foreach (@{$r_keywords}) {
				if ($line =~ /\b$_\b/i) {
					$hit = "yes";
					$anyhit = "yes";
					$yeshits = "something";
					last;
				}
			}

			if ($hit) {
				&toggle_color();
				my($r_rowdata) = {};
				my @row = split(/\|/,$line);
				foreach ($k=0; $k<@row; $k++) {
					$r_rowdata->{$link_fields[$k]} = $row[$k];
				}
				$buffer .= "<tr bgcolor=\"$bgcolor\">\n";
				$buffer .= list_record($r_rowdata,\@link_fields,\@list_fields,$r_in);			
				$buffer .= "</tr>\n";
			}
		}

		if ($anyhit) {
			my $temp_buffer .= qq~
			<table border="0" cellspacing="2" cellpadding="3" width="100%">
			<tr bgcolor="$bg_color{1}"><th colspan="4"><font face="$font_face{1}"
				color="$font_color{1}" size="$font_size{1}">Match in category $file</font>
			</th></tr>
			<tr bgcolor="$bg_color{1}">~;
			foreach (@list_fields) {
				$temp_buffer .= qq~
				<th><font face="$font_face{1}"
				color="$font_color{1}" size="$font_size{1}">$_</font></th>~;
			}

			$temp_buffer .= "<th>&nbsp;</th></tr>\n";
			$buffer = $temp_buffer . $buffer . "</table>\n";
		}
		$output .= $buffer;
	}

	unless ($yeshits) {
		$output = "<h3 align=\"center\">No match...try another keyword.</h3>";
	}
	$output;

}

############################################################################
#
# subroutine product_display
#
# Input:
#
#
# Output:
#
#
############################################################################

sub product_display {

	my($datafile,$productID,$r_in) = @_;
	my($output);
	my @opt_fields;

	$output .= qq~
	<center>
	<form action="$dcscript" method="post">
	<input type="hidden" name="action" value="add_to_cart">
	<input type="hidden" name="productID" value="$productID">
	<input type="hidden" name="database" value="$r_in->{'database'}">
	~;

	#Read in product data
	my ($record,$r_fields) = get_row($datafile, $productID);
	my @row = split (/\|/,$record);
	my $num_fields = @{$r_fields};
	
	for ($j=0; $j < $num_fields; $j++) {
		$r_rowdata->{$link_fields[$j]} = $row[$j];

		if ($r_fields->[$j] =~ /^OPT_(.*)/) {
			push(@opt_fields,$r_fields->[$j]);
		}

		if ($r_fields->[$j] eq "ID") {
			$product_id = $j;
		}
		elsif ($r_fields->[$j] eq "category") {
			$cat_id = $j;
		}
	} 

	$output .= desc_record($r_rowdata,$r_fields,$r_in,"");

	$output .= qq~
	<input type="submit" value="Add to Cart">
	<input type="reset">
	</form>
	~;

	$output;

}

############################################################################
#
# subroutine get_cart_id
#
# Input:
#				None:
#
# Output:
#				customerID -- parsed IPADDRE
############################################################################

sub get_cart_id {

	my $customerID;
	$customerID = get_session_id();
	return $customerID;

}
