#!/usr/local/bin/perl
#
# dcshop_checkout.cgi - part of DCShop by DCScripts
# This program is the form processor for DCShop shopping cart
#
# REVISION:
#
#  29 Dec 1998 - Revision 1.001
#     - Changes made to work with blatmail for NT
#       function send_mail changed to create_mail_message
#
# Copyright  1997-1998 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCShop.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
# 
# LICENSE TO REDISTRIBUTE
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the DCShop software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# DISCLAIMER OF WARRENTY
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH DCSHOP MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF DCSCRIPTS WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPTS LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
###########################################################################

# Require each files...specify correct path to each files

$path = "../../cgi-bin/DCShop";

require "$path/dcshop.setup";
require "$path/dclib.pl";
require "$path/cgi-lib.pl";
require "./dcshop_checkout.setup";

#----DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING---#

# OK Let's read in formdata

ReadParse();

# Send HTTP header to the server
# Note that the output header it not
# terminated yet.  Must print at least one more
# \n ...

print "Content-type: text/html\n";

# Here, let's use remoteHost and Current Time to
# assign a customer ID
# Need to add feature to check duplicate items.

unless ($in{'action'}) {

   print "\n";

   $cart_id = $ENV{'QUERY_STRING'};

   $header = $h_order;
   $sub_header = $sh_order;

   # read in cart data  
   $r_cart = readdata("$cart_dir/$cart_id\.cart");
   
   # Top portion of the output text

   $html_output .= qq~
   <form method="post">
   <input type="hidden" name="action" value="process_form">
   <input type="hidden" name="cart_id" value="$cart_id">~;

   cart_info();

   # also in order_info, @REQUIRED array is formed
      
   order_info();
   
   $required = join(",",@REQUIRED);

   $html_output .= qq~
   </table>
   <input type="hidden" name="param_required" value="$required">
   <input type="submit" value="Submit this Order">
   <input type="reset" value="Reset this Form">
   </form>
   ~;

}
else {

   $in{'Date'} = get_date();

   $cart_id = $in{'cart_id'};

   # read in cart data  
   $r_cart = readdata("$cart_dir/$cart_id.cart");

   # If sub_action is doit, then process the form input and work it
   if ($in{'sub_action'} eq "doit") {
      
      # Create Mail message that will be sent to
      # $email_from and the customer

      $message = create_mail_message(\%in);
      $message = "Date: $in{'Date'}\nOrder Number: $cart_id\n\n" . $message;

      # Next send email to $email_from
      $message_to_yourself =~ s/<!--%ORDER%-->/$message/;
      send_mail($mailprog,$in{'Shipping EMail'},$email_from,$email_subject,$message_to_yourself);

      # Next Email the customer
      # In doing so, add more stuff $email_message is defined in dcshop.setup
      $message_to_customer =~ s/<!--%ORDER%-->/$message/;
      send_mail($mailprog,$email_from,$in{'Shipping EMail'},$email_subject,$message_to_customer);

      
      # If $database was specified, then save it
      if ($order_database) {
         $r_order = add_database("$order_dir/$order_database",\%in);
      }
   
      # Append order information in the user cart as well
      my $user_info = "\n";

      foreach (@{$r_order}) {
         $user_info .= "$_=$in{$_}\n";
      }

      # place order information form elements
      appenddata("$cart_dir/$cart_id.cart",$user_info);

      # Move cart from User_carts to Orders
      rename("$cart_dir/$cart_id.cart","$order_dir/$cart_id.cart");

      $header = $h_last;
      $sub_header = $sh_last;

      cart_info('this');
      order_info('this');
      
      # Now clean up shopping cookie
      
      $expires = "Fri, 31-Dec-89 12:00:00 GMT";
      send_cookie($key,$cart_id,$expires,$domain);
      print "\n";

   }
   else {

      print "\n";
      # First check to make sure that all fields are filled
   
      if ($in{'param_required'}) {
         my @required = split(",",$in{'param_required'});
         foreach (@required) {
            if ($in{$_} eq "") {
               push(@error, $_);
            }
         }
      }

      if (@error) {
         $header = $h_conf_error;
         $sub_header = $sh_conf_error;
         $html_output .= "<blockquote><ul>";
         foreach (@error) {
            $html_output .= "<li>$_\n";
         }
         $html_output .= "</ul></blockquote>";
      }
      else {
         $header = $h_conf;
         $sub_header = $sh_conf;
      }

      $html_output .= qq~
      <form method="post">
      <input type="hidden" name="action" value="process_form">~;

      # place order information form elements
   

      if (@error) {
         cart_info();
         order_info();
      }
      else {
         cart_info('this');
         order_info('this');
         $html_output .= qq~
         <INPUT TYPE="hidden" name="sub_action" value="doit">~;
      }

      $html_output .= qq~
      <INPUT TYPE="hidden" name="cart_id" value="$cart_id">
      <INPUT TYPE="hidden" name="param_required" value="$in{'param_required'}">
      <INPUT TYPE="SUBMIT" VALUE="Complete this Order">
      ~;

      $html_output .= qq~
      </FORM>
      </td>
      </tr>
      ~;


   }
}

$imageurl = $secureimgurl;

%namespace = (
   IMAGES => $imageurl,
    HEADER => $header,
    SUBHEADER => $sub_header,
    MENU => $menu,
    HTMLOUTPUT => $html_output
);

display_output($templatefile,\%namespace); 

exit(0);

#------END OF MAIN PROGRAM-------#

#
# function order_info
#

sub order_info {

   my $stat_flag = shift;

   $html_output .= qq~
   <table width="100%" border="0" cellspacing="1" cellpadding="3">~;

   if ($order_forms{'Shipping Form'} eq "On") {

      toggle_color('reset');

      $html_output .= qq~
         <tr bgcolor="$bg_color{'1'}" align="right">
         <th align="right" colspan="2"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         Shipping Information
         </font></th></tr>~;

      toggle_color();

      unless ($stat_flag) {

         $html_output .= qq~
            <tr valign="top" align="left">
            <th align="right" bgcolor="$bgcolor"><font
            size="$fontsize" face="$fontface" color="$fontcolor">
            Shipping Method<font color="#FF0000">*</font>:
            </font></th>
            <td align="left" bgcolor="$bgcolor">
            <select name="Shipping Method">
            <option value=''>---Select---
            ~;

         foreach (@shipping_method_fields) {

            if ($_ eq $in{'Shipping Method'}) {
               $html_output .= qq~
               <option value="$_" selected>$_ (\$$shipping_method_price{$_})~;
            }
            else {
               $html_output .= qq~
               <option value="$_">$_ (\$$shipping_method_price{$_})~;
            }
         }

         $html_output .= qq~
            </select>~;
      }
         
      $html_output .= qq~
      </td></tr>
      ~;

      toggle_color('reset');

      foreach (@shipping_form_fields) {
         my $required = '';
         if ($shipping_form{$_} =~ /required/ && $stat_flag eq '') {
            $required = "<font color=\"#FF0000\">*</font>";
         }
         my $form_row .= form($_, $shipping_form{$_},$in{$_},$stat_flag);
         # Remove 'Shipping' from display name
         s/Shipping\s(.*)/$1/;
         $html_output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_$required:
         </font>
         </th>~;
         toggle_color();
         $html_output .= qq~
         <td align="left" bgcolor="$bgcolor">$form_row</td></tr>
         ~;
         toggle_color();
      }
   }
   
   if ($order_forms{'Billing Form'} eq "On") {

      $html_output .= qq~
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <th align="right" colspan="2"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         Billing Information
         </font></th>
         </tr>
         ~;

      if ($in{'Billing Same As Shipping'} eq "Yes") {
         foreach (@billing_form_fields) {
            unless ($_ eq 'Billing Same As Shipping') {
               my $temp = $_;
               $temp =~ s/Billing/Shipping/m;
               $in{$_} = $in{$temp};
            }
         }
      }
      
      toggle_color('reset');
      foreach (@billing_form_fields) {
         my $required = '';
         if ($billing_form{$_} =~ /required/ && $stat_flag eq '') {
            $required = "<font color=\"#FF0000\">*</font>";
         }
         my $form_row .= form($_, $billing_form{$_},$in{$_},$stat_flag);
         # Remove 'Billing' from display name
         s/Billing\s(.*)/$1/;
         $html_output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_$required:
         </font>
         </th>~;

         toggle_color();
         $html_output .= qq~
         <td align="left" bgcolor="$bgcolor">$form_row</td>
         </tr>
         ~;
         toggle_color();
      }
   }

   if ($order_forms{'Credit Info Form'} eq "On") {

      $html_output .= qq~
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <th align="right" colspan="2"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         Payment Information
         </font></th>
         </tr>
         ~;
      toggle_color('reset');
      foreach (@credit_form_fields) {
         my $required = '';

         if ($credit_form{$_} =~ /required/ && $stat_flag eq '') {
            $required = "<font color=\"#FF0000\">*</font>";
         }

         my $form_row .= form($_, $credit_form{$_},$in{$_},$stat_flag);
         $html_output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_$required:
         </font>
         </th>~;
         
         toggle_color();   
         $html_output .= qq~
         <td align="left" bgcolor="$bgcolor">$form_row</td>
         </tr>
         ~;
         toggle_color();

      }

   }

   $html_output .= "</table>\n";

}

###
# function form
# Creates form elements
#
####

sub form {

   my ($name,$value,$default,$stat_flag) = @_;
   my ($type,@others) = split(/\|/,$value);
   my ($row);

   # Check and see if the element is required
   
   if ($others[-1] eq "required") {
      push(@REQUIRED,$_);
      pop(@others);
   }

   if ($type eq "text") {
      unless ($stat_flag) {
         $row .= qq~
         <input type="text" name="$name" size="$others[0]" value="$default">~;
      }
      else {
         $row .= qq~
         <input type="hidden" name="$name" value="$default">$default~;
      }
   }
   elsif ($type eq "checkbox") {
      unless ($stat_flag) {
         foreach (@others) {
            if ($_ =~ /$default/) {
               $row .= qq~
                  <input type="checkbox" name="$name" value="$_" checked>$_
               ~;
            }
            else {
               $row .= qq~
                  <input type="checkbox" name="$name" value="$_">$_
               ~;
            }
         }
      }
      else {
               $row .= qq~
                  <input type="hidden" name="$name" value="$_">$_~;
      }
   }
   elsif ($type eq "radio") {
      unless ($stat_flag) {
         foreach (@others) {
            if ($_ eq $default) {
               $row .= qq~
                  <input type="radio" name="$name" value="$_" checked>$_
               ~;
            }
            else {
               $row .= qq~
                  <input type="radio" name="$name" value="$_">$_
               ~;
            }
         }
      }
      else {
         $row .= qq~
            <input type="hidden" name="$name" value="$_">$_~;
      }
   }
   elsif ($type eq "select") {
      unless ($stat_flag) {
         $row .= qq~
         <select name="$name">
         <option value=''>---Select---
         ~;
         foreach (@others) {
            if ($_ =~ /$default/) {
               $row .= qq~
               <option value="$_" selected>$_
               ~;
            } else {
               $row .= qq~
               <option value="$_">$_
               ~;
            }
         }
   
         $row .= qq~
         </select>~;
      }
      else {
         $row .= qq~
            <input type="hidden" name="$name" value="$default">$default~;
      }
   }
   
   return $row;
   
}



###
# subroutine check_required
#
###

sub check_required {

   my($r_data) = @_;
   my(@required, @ERROR);

   @required = split(",",$r_data->{'param_required'});

   foreach (@required) {
      if ($r_data->{$_} eq "") {
         push(@ERROR, $_);
      }
   }

   return \@ERROR;
}


###
###
### subroutine add_database
###

sub add_database {

   my($file,$r_data) = @_;
   my($data_in, @order,@data);

   push (@order,'Date','cart_id','Shipping Method',@shipping_form_fields,
   @billing_form_fields,@credit_form_fields,'Order Status');

   # If database doesn't exist, create it.
   # Fill first row with database fields
   unless (-e $file) {
      my @temp;
      $temp[0] = join("\|",@order);
      $temp[0] .= "\n";
      writedata($file,\@temp);
   }

   $r_data->{'Order Status'} = $order_status[0];

   foreach (@order) {
      $r_data->{$_} =~ s/\cM//g;
      $r_data->{$_} =~ s/\n\n//g;
      $r_data->{$_} =~ s/\n//g;
      $r_data->{$_} =~ s/\|//g;
      push(@data,$r_data->{$_});
   }

   $data_in = join("\|",@data);
   appenddata($file,$data_in);

   return \@order;
}


####
# subroutine create_mail_message
# Create a file with mail message
####

sub create_mail_message {

   my $r_data = shift;

   my ($subject, $message, $id);
   my ($total_nontaxable, $total_taxable, $total_tax, $final, $shipping);
   my ($id,$name,$price,$quantity,$options,$amount);

   # Format for the email

format FOUT =
@<<<<<<<<< @<<<<<<<<<<<<<<<<<<< @<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<<  @<<<<<<<<<
$id,$name,$unit_price,$options,$quantity,$amount
------------------------------------------------------------------------------------------
.

   # Open The Mail Program

   $id = $cart_fields[0];
   $name = $cart_fields[1];
   $unit_price = $cart_fields[2];
   $quantity = $cart_fields[3];
   $options = $cart_fields[4];
   $amount = 'Amount';

   open(FOUT,">$cart_dir/$cart_id.msg") or 
         my_die("Error in dcshop_checkout::create_mail_message 
               Can't open $cart_dir/$cart_id.msg",$!);
      write(FOUT);

   # Read in items into reference array
   my $r_cart = readdata("$cart_dir/$cart_id.cart");

   foreach (@{$r_cart}) {
      chomp;
      my @row = split /\|/;
      my $j = -1;
      my $taxable;
   
      foreach (@row) {
         $j++;
         if ($cart_fields[$j] eq "ID") {
            $id = $_;
         }
         elsif ($cart_fields[$j] eq "Name") {
            $name = $_;
         }
         elsif ($cart_fields[$j] eq "Price") {
            $unit_price = sprintf("%.2f", $_);
            $price = sprintf("%.2f", $_);
         }
         elsif ($cart_fields[$j] eq "Quantity") {
            $quantity = $_;
         }
         elsif ($cart_fields[$j] eq "Taxable") {
            $taxable = $_;
         }
         elsif ($cart_fields[$j] eq "Options"){
            $options = '';
            my (@options) = split /,/;
            foreach (@options) {
               my ($temp,$opt_price);
               my ($option,$choice) = split /=/;
               if ($choice =~ /::/) {
                  ($temp,$opt_price) = split(/::/,$choice);
                  $price += $opt_price;
                  $choice = $temp;
                  $options .= "$choice (+\$$opt_price) ";
               }
               else {
                  $options .= "$choice ";
               }
            }
         }
      }

      $sub_total = sprintf("%.2f", $price * $quantity);
      $amount = $sub_total;   
      if ($taxable) {
         $total_taxable += $sub_total;
      }
      else {
         $total_nontaxable += $sub_total;
      }
   
      $message .= "\$$sub_total\n";

      write(FOUT);   
   }

   close(FOUT);

   open(F,"$cart_dir/$cart_id.msg") or my_die("Can't open $cart_dir/$cart_id.msg",$!);
   {  local $/ = undef;
      $message = <F>; }
   close(F);

   unlink("$cart_dir/$cart_id.msg");
   
   $total_nontaxable = sprintf("%.2f", $total_nontaxable);
   $total_taxable = sprintf("%.2f", $total_taxable);
   $total_tax = sprintf("%.2f", $total_taxable*$sales_tax);
   $final = sprintf("%.2f", $total_nontaxable + $total_taxable + $total_tax);

   # You may want to modify this section to make your email look nice
   $message .= "Total (Non-Taxable):______________\$$total_nontaxable\n";
   $message .= "Total (Taxable):__________________\$$total_taxable\n";
   $message .= "Sales Tax:________________________\$$total_tax\n";
   $shipping = $shipping_method_price{$r_data->{'Shipping Method'}};
   $message .= "Shipping ($r_data->{'Shipping Method'}):______\$$shipping\n";
   
   $final += $shipping;
   $final = sprintf("%.2f",$final);
   $message .= "Total:____________________________\$$final\n";
      
   return $message;

}

#
# function cart_info
#

sub cart_info {

   my $stat_flag = shift;

   $html_output .= qq~
   <table width="100%" border="0" cellspacing="1" cellpadding="3">
   <tr bgcolor="$bg_color{'1'}" align="left">~;

   foreach (keys %form_options) {
      if ($form_options{$_}) {
         $html_output .= qq~
         <input type="hidden" name="$_" value="$form_options{$_}">
         ~;
      }
   }

   foreach (@cart_fields) {
      unless ($_ eq "Taxable") {
         $html_output .= qq~
         <th><font face="$font_face{1}"
            color="$font_color{1}" size="$font_size{1}">$_</font></th>
         ~;
      }
   }
   
   $html_output .= qq~
      <th><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">Amount</font></th>
   </tr>
   ~;

   unless (@{$r_cart}) {
      error('empty_cart');
      exit(0);
   }

   toggle_color('reset');

   foreach (@{$r_cart}) {
      chomp;
      my @row = split /\|/;
      $html_output .= "<tr valign=\"top\" align=\"left\" bgcolor=\"$bgcolor\">\n";

      my $j = -1;
      my $taxable;

      foreach (@row) {

         $j++;
         if ($cart_fields[$j] eq "ID") {
            $id = $_;
            $html_output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">
               $id</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "Price") {
            $price = sprintf("%.2f", $_);
            $html_output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">
               \$$price</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "Quantity") {
            $quantity = $_;
            $html_output .= qq~
            <td><font
               size="$fontsize" face="$fontface" 
               color="$fontcolor">$_</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "Taxable") {
            $taxable = $_;
         }
         elsif ($cart_fields[$j] eq "Options") {
            $html_output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">~;
            my (@options) = split /,/;
            foreach (@options) {
               my ($temp,$opt_price);
               my ($option,$choice) = split /=/;
               if ($choice =~ /::/) {
                  ($temp,$opt_price) = split(/::/,$choice);
                  $price += $opt_price;
                  $choice = $temp;
                  $html_output .= qq~
                     $option: $choice (+\$$opt_price)<br>~;
               }
               elsif ($_ eq "NA") {
                  $html_output .= qq~
                     &nbsp;~;
               }
               else {
                  $html_output .= qq~
                     $option: $choice<br>~;
               }
            }

            $html_output .= qq~
               </font>
            </td>~;
         }
         else {
            $html_output .= qq~
            <td>&nbsp;<font
               size="$fontsize" face="$fontface" color="$fontcolor">
               $_</font>
            </td>~;
         }
         
      }

      $sub_total = sprintf("%.2f", $price * $quantity);

      if ($taxable) {
         $total_taxable += $sub_total;
      }
      else {
         $total_nontaxable += $sub_total;
      }

      $html_output .= qq~
      <td align="right"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         \$$sub_total</font>
      </td>
      </tr>~;

      toggle_color();

   }

   $total_nontaxable = sprintf("%.2f", $total_nontaxable);
   $total_taxable = sprintf("%.2f", $total_taxable);
   $total_tax = sprintf("%.2f", $total_taxable*$sales_tax);
   $final = sprintf("%.2f", $total_nontaxable + $total_taxable + $total_tax);

   $html_output .= qq~
   <tr>
      <td colspan="6" align="right"><hr size="1">$taxable</td></tr>
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Total (Non-Taxable):
      </font></th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\$$total_nontaxable</font></td></tr>
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Total (Taxable):
      </font></th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\$$total_taxable</font></td></tr>
   <tr>
      <td colspan="4" align="right" valign="top">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Sales Tax:
      </font>
      </th>
      <td align="right"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\$$total_tax</font></td></tr>~;

   if ($stat_flag) {
      my $shipping = sprintf("%.2f", $shipping_method_price{$in{'Shipping Method'}} );
      $html_output .= qq~
      <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Shipping ($in{'Shipping Method'}):
      </font>
      </th>
      <td align="right" valign="top">
      <input type="hidden" name="Shipping Method" value="$in{'Shipping Method'}">
      <font size="$fontsize" face="$fontface" 
         color="$fontcolor">\$$shipping</font></td></tr>~;
      $final += $shipping;
   }        

   $final = sprintf("%.2f",$final);
   $html_output .= qq~
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Total:
      </font>
      </th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\$$final</font></td></tr>
   <tr>
      <td colspan="6" align="right"><hr size="1"></td></tr>
   </table>
   ~;


}
